/*
	NOMBRES.C
	Genera una lista de NUM nombres (un numero muy grande si se requiere)
	para usarse con el programa ORDXTRN.C de orden externo.
	OJO> utiliza los archivos NOM.TXT, APP.TXT y APM.TXT para generar los
	nombres, genera un archivo NAMES.TXT que utiliza ORDXTRN.C
	Este archivo generado puede llegar a ser bastante grande
*/
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>

#define MAX 20
#define NUM 10000
#define LEN 128

void cuatrodigs(char *, int);

void main()
{
	FILE *fn, *fa, *fw, *fm;
	char nombre[MAX], apellido1[MAX], apellido2[MAX];
	char num1[6], num2[6], total[LEN];
	long clave=1;

	srand(time(NULL));
	fflush(stdin);
	clrscr();
	if((fn=fopen("nom.txt","rt"))!=NULL &&
		 (fa=fopen("app.txt","rt"))!=NULL &&
		 (fm=fopen("apm.txt","rt"))!=NULL &&
		 (fw=fopen("names.txt","wb"))!=NULL)
	{
		printf("Registro #");
		strcpy(nombre,"");	strcpy(apellido1,"");	strcpy(apellido2,"");
		strcpy(total,"");
		while(!feof(fn) && clave<=NUM)
		{
			fgets(nombre, MAX, fn);
			if(feof(fn))
				break;
			nombre[strlen(nombre)-1]='\0';
			while(!feof(fa) && clave<=NUM)
			{
				fgets(apellido1, MAX, fa);
				if(feof(fa))
					break;
				apellido1[strlen(apellido1)-1]='\0';
				while(!feof(fm) && clave<=NUM)
				{
					fgets(apellido2, MAX, fm);
					if(feof(fm))
						break;
					apellido2[strlen(apellido2)-1]='\0';
					cuatrodigs(num1,rand()%10000);
					cuatrodigs(num2,rand()%10000);
					strcpy(total,num1);
					strcat(total,num2);
					strcat(total," ");
					strcat(total,nombre);
					strcat(total," ");
					strcat(total,apellido1);
					strcat(total," ");
					strcat(total,apellido2);
					strcat(total,"\n");
					fprintf(fw,"%s",total);
					fflush(fw);
					gotoxy(11,1);
					printf("%ld",clave);
					clave++;
				}
				rewind(fm);
				fflush(stdin);
			}
			rewind(fa);
			fflush(stdin);
		}
		fclose(fn);
		fclose(fa);
		fclose(fw);
	}
	else
		printf("Error!\nNo se pudo abrir el archivo.");
}

/*convierte un entero a una cadena con cuatro digitos*/
void cuatrodigs(char cad[], int valor)
{
	char aux[6]="";

	strcpy(cad,"");
	if(valor == 0)
		strcpy(cad,"0000");
	else if(valor/10 == 0)	//solo tiene 1 digito
	{
		strcpy(cad,"000");
		strcat(cad,itoa(valor,aux,10));
	}
	else if(valor/100 == 0)//solo tiene 2 digitos
	{
		strcpy(cad,"00");
		strcat(cad,itoa(valor,aux,10));
	}
	else if(valor/1000 == 0)//solo tiene 3 digitos
	{
		strcpy(cad,"0");
		strcat(cad,itoa(valor,aux,10));
	}
	else	//tiene 4 digitos
		strcat(cad,itoa(valor,aux,10));
}
